poj 1862 Stripies 【优先队列】

简介: 点击打开题目 Stripies Time Limit: 1000MS   Memory Limit: 30000K Total Submissions: 12587   Accepted: 5957 Description Our...

点击打开题目

Stripies
Time Limit: 1000MS   Memory Limit: 30000K
Total Submissions: 12587   Accepted: 5957

Description

Our chemical biologists have invented a new very useful form of life called stripies (in fact, they were first called in Russian - polosatiki, but the scientists had to invent an English name to apply for an international patent). The stripies are transparent amorphous amebiform creatures that live in flat colonies in a jelly-like nutrient medium. Most of the time the stripies are moving. When two of them collide a new stripie appears instead of them. Long observations made by our scientists enabled them to establish that the weight of the new stripie isn't equal to the sum of weights of two disappeared stripies that collided; nevertheless, they soon learned that when two stripies of weights m1 and m2 collide the weight of resulting stripie equals to 2*sqrt(m1*m2). Our chemical biologists are very anxious to know to what limits can decrease the total weight of a given colony of stripies. 
You are to write a program that will help them to answer this question. You may assume that 3 or more stipies never collide together. 

Input

The first line of the input contains one integer N (1 <= N <= 100) - the number of stripies in a colony. Each of next N lines contains one integer ranging from 1 to 10000 - the weight of the corresponding stripie.

Output

The output must contain one line with the minimal possible total weight of colony with the accuracy of three decimal digits after the point.

Sample Input

3
72
30
50

Sample Output

120.000

题目翻译:给出一个n,然后给出n个菌落的质量,任意两个菌落m1、m2相撞,会合并成一个新菌落,并且质量会变成 2*sqrt(m1*m2).

求:如何安排菌落相撞的顺序,才能使最后相撞后只剩一个时的质量最小?


解题思路:每次都安排最大的两个相撞,直到最后剩下一个。使用优先队列来解决每次都排序的问题。注意精度问题!


#include<cstdio>
#include<queue>
#include<cmath>
#include<algorithm>
using namespace std;
int main(){
    priority_queue<double>q;
    int n;
    double a,b,c;
    while(~scanf("%d",&n)){
        while(!q.empty())
            q.pop();
        for(int i=0;i<n;i++){
            scanf("%lf",&a);
            q.push(a);
        }
        while(q.size()>1){
            a=q.top(); q.pop();
            b=q.top(); q.pop();
            c=2*sqrt(a*b);
            q.push(c);
        }
        printf("%.3f\n",q.top());
    }
    return 0;
}





目录
相关文章
|
2月前
【Leetcode 2583】二叉树中的第K大层和 —— 优先队列 + BFS
解题思路: - 使用队列保存节点,按层序依次保存该层节点 - 使用优先队列保存每层节点值的总和,最后剔除前k个大数即可得到
|
人机交互
POJ-2524,Ubiquitous Religions(并查集模板题)
POJ-2524,Ubiquitous Religions(并查集模板题)
|
人工智能 BI iOS开发
codeforces1140C Playlist(排序+优先队列)
codeforces1140C题解(排序+优先队列)
1125 0
|
人工智能 C++ Windows
FJUT - OJ优先队列专题题解
题目链接http://120.78.128.11/Contest.jsp?cid=18 题面不贴了 都是英文题,看的我心力憔悴 =7=   一、Ugly Numbers   题目说一个数的质因数只包含2、3或者5(一个或多个),就是丑陋数。
1222 0